<?php

## wikifields.php
## support for defining wiki field configuration in a wiki page

SDV($FieldConfPage, $FieldListPage);

# syntax

$FieldDefPattern = "=field\s+([A-Za-z]+)([^\n]*)";
$FieldOptPattern = "([a-z]+)=('([^']*)'|[A-Za-z0-9]*)";
$DoubleBrackets["/^$FieldDefPattern/e"] = 
'"". FormatFieldDef(stripslashes("$1"), stripslashes("$2"));';

function FormatFieldDef($name,$def) {
  global $FieldOptPattern, $WikiWordPattern, $AsSpacedFunction;
  $def = preg_replace("/\\b($WikiWordPattern)/","`$1",$def);
  $out = ":Field [[$name:/ ".$AsSpacedFunction($name)."]]:";
  preg_match_all("/$FieldOptPattern/", $def,
		 $opt_match, PREG_SET_ORDER);
  foreach ($opt_match as $opt) {
    $val = isset($opt[3]) ? $opt[3] : $opt[2];
    $out .= "$opt[1]: '$val'<br />";
  }
  return $out;
}

function FieldConfFromPage() {
  global $FieldConfPage, $FieldDefPattern, $FieldOptPattern;
  $page = ReadPage($FieldConfPage, '');
  $fields = array();

  preg_match_all("/^$FieldDefPattern/m", $page['text'],
		 $field_match, PREG_SET_ORDER);
  foreach ($field_match as $field) {
    $fn = $field[1];
    $fields[$fn] = array();
    preg_match_all("/$FieldOptPattern/", $field[2],
		   $opt_match, PREG_SET_ORDER);
    foreach ($opt_match as $opt) {
      $fields[$fn][$opt[1]] = isset($opt[3]) ? $opt[3] : $opt[2];
    }
  }
  return $fields;
}

$FieldConf = FieldConfFromPage();

?>