<?php
$FmtWikiLinkPreShared = $FmtWikiLink;
$FmtWikiLink = 'FmtWikiLinkShared';

SDV($AuthorGroup, 'Profiles');
SDV($SharedGroups, array("PmWiki", &$AuthorGroup));
SDV($SharedGroupsPage, $FieldListPage);

function ParseSharedGroups() {
  global $SharedGroupsPage, $SharedGroups, $GroupNamePattern, $WikiDir,
    $GetFieldUrl;
  
  $oWikiDir = $WikiDir;
  $WikiDir = "wiki.d";
  $page = ReadPage($SharedGroupsPage, '');
  $WikiDir = $oWikiDir;
  $groups = $SharedGroups;
  preg_match_all("/^[*#]+\s*(\\[\\[|)({{|)($GroupNamePattern)[\\/.]/m", $page['text'], $group_match, PREG_SET_ORDER);
  foreach ($group_match as $group) {
    $groups[] = $group[3];
  }
  if (count($groups)>0) $SharedGroups = $groups;
}

ParseSharedGroups();

foreach ($SharedGroups as $shg) {
  $SharedGroupsIndex[$shg] = 1;
}

function SharedGroup($gname) {
  global $SharedGroupsIndex;
  return $SharedGroupsIndex[$gname];
}

function FmtWikiLinkShared($pat,$ref,$btext,$out=NULL,$rname=NULL) {
  global $FmtWikiLinkPreShared, $ScriptUrl, $WikiDir, $GetFieldUrl,
    $WikiLibDirs, $Field;
  $pname = $FmtWikiLinkPreShared($pat, $ref, $btext, 'PageName', $rname);
  if ($out == 'PageName') return $pname;
  if (preg_match("/^([^\\.]+)\\.(.+)/", $pname, $match)) {
    $group = $match[1]; $title = $match[2];
    $field = $Field;
    if (SharedGroup($group)) {
      $field = '';
    }
    $oScriptUrl = $ScriptUrl;
    $oWikiDir = $WikiDir;
    $ScriptUrl = $GetFieldUrl($field);
    $WikiDir = GetFieldWikiDir($field);
    $oWikiLibDirs = $WikiLibDirs;
    $WikiLibDirs = array(&$WikiDir, GetFieldWikiLibDir($field));
    $out = $FmtWikiLinkPreShared($pat, $ref, $btext, $out, $rname);
    $ScriptUrl = $oScriptUrl;
    $WikiDir = $oWikiDir;
    $WikiLibDirs = $oWikiLibDirs;
    return $out;
  }
  return $FmtWikiLinkPreShared($pat, $ref, $btext, $out, $rname);
}

function ReadSharedPage($pagename,$defaulttext=NULL) {
    global $WikiDir,$WikiLibDirs;
    if (SharedGroup(FmtPageName('$Group',$pagename))) {
        $oWikiDir = $WikiDir;
        $oWikiLibDirs = $WikiLibDirs;
        $WikiDir = "wiki.d";
        $field = '';
        $WikiLibDirs = array(&$WikiDir, GetFieldWikiLibDir($field));
        $page = ReadPage($pagename,$defaulttext);
        $WikiDir = $oWikiDir;
        $WikiLibDirs = $oWikiLibDirs;
    } else
        $page = ReadPage($pagename,$defaulttext);
    return $page;
}

function SharedPageExists($pagename) {
    global $WikiDir,$WikiLibDirs;
    if (SharedGroup(FmtPageName('$Group',$pagename))) {
        $oWikiDir = $WikiDir;
        $oWikiLibDirs = $WikiLibDirs;
        $WikiDir = "wiki.d";
        $field = '';
        $WikiLibDirs = array(&$WikiDir, GetFieldWikiLibDir($field));
        $pe = PageExists($pagename);
        $WikiDir = $oWikiDir;
        $WikiLibDirs = $oWikiLibDirs;
    } else
        $pe = PageExists($pagename);
    return $pe;
}

if (SharedGroup($AuthorGroup) && $action=="diff") {
/*  $FmtDiffAuthor = 'FmtDiffAuthorShared'; */
  $WikiLibDirs[] = $WikiLibDirs[count($WikiLibDirs)-1];
  $WikiLibDirs[count($WikiLibDirs) - 1] = GetFieldWikiDir('');
  SDV($DiffAuthorPageExistsFmt,"<a class='authorlink'
   href='".$GetFieldUrl('')."/\$DiffAuthorPage'>\$DiffAuthor</a>");
}
/*
function FmtDiffAuthorShared($authorPage) {
  global $DiffAuthorPageExistsFmt, $DiffAuthorPageMissingFmt, $AuthorGroup,
  $ScriptUrl, $WikiDir, $GetFieldUrl;
  if (SharedGroup($AuthorGroup)) {
    $oScriptUrl = $ScriptUrl;
    $oWikiDir = $WikiDir;
    $ScriptUrl = $GetFieldUrl('');
    $WikiDir = "wiki.d";
  }
  $out = FmtPageName(PageExists($authorPage) ? 
    $DiffAuthorPageExistsFmt : $DiffAuthorPageMissingFmt, $pagename);
    if (SharedGroup($AuthorGroup)) {
    $ScriptUrl = $oScriptUrl;
    $WikiDir = $oWikiDir;
  }
  return $out;
}
*/
?>